Imports System.ComponentModel.DataAnnotations
Imports System.ComponentModel.DataAnnotations.Schema

Namespace DataPointsDemo.DomainClasses
	Public Enum TwitterExperience
		Newbie
		BeenAround
		Ninja
	End Enum

	Public Enum TweetRating
		Suxorz = 0
		WorksForMe = 1
		WatchOutAPlusK = 2
	End Enum

	Public Enum MaxLength As Long
		Max = 2147483648L
		Min = 255L
	End Enum

	Public Class Tweeter
		Public Sub New()
			Tweets = New List(Of Tweet)
		End Sub

		Public Property Id As Integer
		<Required>
		Public Property Name As String
		<Column("ExperienceCode")>
		Public Property Experience As TwitterExperience
		<MaxLength(30), MinLength(5)>
		Public Property UserName As String
		<RegularExpression("(\w[-._\w]*\w@\w[-._\w]*\w\.\w{2,3})")>
		Public Property Email As String
        Public Property Bio As String
        Public Property CreateDate() As Date
        Public Property Avatar() As Byte()
        Public Property Tweets() As ICollection(Of Tweet)
        <Timestamp>
        Public Property RowVersion() As Byte()
        Public Property MaxLength() As MaxLength 'just to see effect of specifying the enum as long
        Public ReadOnly Property AliasPlusName() As String
            Get
                Return Name & "(" & UserName & ")"
            End Get
        End Property
    End Class

    Public Class Tweet
        Public Property Id As Integer
        Public Property CreateDate As Date
        Public Property Content As String
        <Column("RatingCode")>
        Public Property Rating As TweetRating
        Public Property [Alias]() As Tweeter
        Public Property AliasId As Integer
    End Class

End Namespace

