Imports System.ComponentModel.DataAnnotations

Namespace DataPointsDemo.DomainClasses
    Public Class Tweeter
        Public Sub New()
            Tweets = New List(Of Tweet)
        End Sub

        Public Property Id As Integer
        <Required>
        Public Property Name As String

        <MaxLength(10)>
        Public Property Experience As String

        <MaxLength(30), MinLength(5)>
        Public Property UserName As String

        <RegularExpression("(\w[-._\w]*\w@\w[-._\w]*\w\.\w{2,3})")>
        Public Property Email As String
        Public Property Bio As String
        Public Property CreateDate() As Date
        Public Property Avatar() As Byte()
        Public Property Tweets() As ICollection(Of Tweet)

        <Timestamp>
        Public Property RowVersion() As Byte()
        Public ReadOnly Property AliasPlusName() As String
            Get
                Return Name & "(" & UserName & ")"
            End Get
        End Property
    End Class

    Public Class Tweet
        Public Property Id As Integer

        Public Property CreateDate As Date

        Public Property Content As String
        <Range(1, 5)>
        Public Property Rating As Integer
        Public Property [Alias]() As Tweeter
        Public Property AliasId As Integer
    End Class

End Namespace
